DEFINT A-Z
CONST Num$ = "0123456789"
ON ERROR GOTO Oops
CLS
LOCATE 2, 18, 1
COLOR 15
PRINT "LOGARITHMIC FUNCTIONS - ENHANCED CALCULATOR";
Begin:
VIEW PRINT 4 TO 23
COLOR 14
CLS
LOCATE 23, 27, 1
PRINT "*** Hit <Enter> to Quit ***";
LOCATE 4, 21
COLOR 7
PRINT "1. KNOWN: Number & Base, CALCULATE Log";
LOCATE 6, 21
PRINT "2. KNOWN: Base & Log, CALCULATE Number";
LOCATE 8, 21
PRINT "3. KNOWN: Number & Log, CALCULATE Base";
LOCATE 10, 24
PRINT "Choose: ";
DO
    An$ = INKEY$
    IF An$ = CHR$(13) THEN
        COLOR 7
        VIEW PRINT
        CLS
        SYSTEM
    ELSEIF LEN(An$) THEN
        IF INSTR("123", An$) THEN
            EXIT DO
        END IF
    END IF
LOOP
COLOR 14
PRINT "<"; An$; ">";
Ans = VAL(An$)
COLOR 7
LOCATE 12, 11
PRINT "*** (Scientific Notation Format {nnn...Dn..} Allowed) ***";
COLOR 14
IF Ans = 1 THEN
    LOCATE 4, 46
ELSEIF Ans = 2 THEN
    LOCATE 6, 43
ELSE
    LOCATE 8, 45
END IF
PRINT "CALCULATE ";
IF Ans = 1 THEN
    PRINT "Log";
ELSEIF Ans = 2 THEN
    PRINT "Number";
ELSE
    PRINT "Base";
END IF
LOCATE 13, 1
COLOR 15
PRINT STRING$(80, "");
IF Ans = 2 THEN
    GOTO Choice2NumberBase
ELSEIF Ans = 3 THEN
    GOTO Choice3Number
END IF
Choice1Number:
GOSUB Locate15to23
LOCATE 15, 1
GOSUB CheckNumber
IF Number$ = "" THEN
    GOTO Begin
ELSEIF Bad THEN
    Bad = 0
    GOTO Choice1Number
END IF
Choice1NumberBase:
VIEW PRINT 17 TO 24
COLOR 14
CLS
GOSUB GoBackMsg
LOCATE 17, 1
GOSUB CheckNumberBase
IF NumberBase$ = "" THEN
    GOTO Choice1Number
ELSEIF NuberBase$ = "e" THEN
    GOTO Choice1Formula
ELSEIF Bad THEN
    Bad = 0
    GOTO Choice1NumberBase
END IF
'
'**** Calculation Formula One ****
'
Choice1Formula:
IF NumberBase$ = "e" THEN
    LogOfNumber# = LOG(Number#)
ELSE
    LogOfNumber# = LOG(Number#) / LOG(NumberBase#)
    '
    '** Check to see if Scientific Notation is really required **
    '
    NumberBase$ = MID$(STR$(NumberBase#), 2)
    '
END IF
LOCATE 19, 1
COLOR 7
IF NumberBase$ = "e" THEN
    Formula$ = "Ln(" + MID$(STR$(Number#), 2) + ") = "
ELSE
    Formula$ = "Ln(" + MID$(STR$(Number#), 2) + ") / Ln(" + MID$(STR$(NumberBase#), 2) + ") = "
END IF
PRINT "LOG = "; Formula$;
COLOR 14
IF LogOfNumber# < 0 THEN
    LogOfNumber$ = STR$(LogOfNumber#)
ELSE
    LogOfNumber$ = MID$(STR$(LogOfNumber#), 2)
END IF
PRINT LogOfNumber$;
GOSUB RestartMsg
GOSUB WaitingForEnter
GOTO Begin
Choice2NumberBase:
GOSUB Locate15to23
LOCATE 15, 1
GOSUB CheckNumberBase
IF NumberBase$ = "" THEN
    GOTO Begin
ELSEIF NumberBase$ = "e" THEN
    GOTO Choice2Log
ELSEIF Bad THEN
    Bad = 0
    GOTO Choice2NumberBase
END IF
Choice2Log:
GOSUB Locate17to22
LOCATE 17, 1
GOSUB CheckLog
IF LogOfNumber$ = "" THEN
    GOTO Choice2NumberBase
ELSEIF Bad THEN
    Bad = 0
    GOTO Choice2Log
END IF
'
'**** Calculation Formula Two ****
'
IF NumberBase$ = "e" THEN
    Number# = EXP(1#) ^ LogOfNumber#
ELSE
    Number# = NumberBase# ^ LogOfNumber#
    '
    '** Check to see if Scientific Notation is really required **
    '
    NumberBase$ = MID$(STR$(NumberBase#), 2)
    '
END IF
IF MID$(STR$(Number#), 2) = "1.#INF" THEN
    ERROR 6
ELSEIF Number# = 1 AND LogOfNumber# <> 0 THEN
    ERROR 6
ELSEIF Number# = 0 THEN
    ERROR 6
END IF
LOCATE 19, 1
COLOR 7
IF NumberBase$ = "e" THEN
    Formula1$ = "e ^" + STR$(LogOfNumber#) + " = "
    Formula2$ = MID$(STR$(EXP(1#)), 2) + " ^" + STR$(LogOfNumber#) + " ="
    IF LEN(Formula1$) + LEN(Formula2$) + LEN(STR$(Number#)) > 70 THEN
        Formula$ = Formula1$
    ELSE
        Formula$ = Formula1$ + Formula2$
    END IF
ELSE
    Formula$ = MID$(STR$(NumberBase#), 2) + " ^" + STR$(LogOfNumber#) + " ="
END IF
PRINT "NUMBER = "; Formula$;
COLOR 14
PRINT Number#;
Number$ = MID$(STR$(Number#), 2)
GOSUB RestartMsg
GOSUB WaitingForEnter
GOTO Begin
Choice3Number:
GOSUB Locate15to23
LOCATE 15, 1
GOSUB CheckNumber
IF Number$ = "" THEN
    GOTO Begin
ELSEIF Bad THEN
    Bad = 0
    GOTO Choice3Number
END IF
Choice3Log:
GOSUB Locate17to22
LOCATE 17, 1
GOSUB CheckLog
IF LogOfNumber$ = "" THEN
    GOTO Choice3Number
ELSEIF Bad THEN
    Bad = 0
    GOTO Choice3Log
ELSEIF LogOfNumber# = 0 THEN
    GOSUB Choice3Formula
    ERROR 11
ELSEIF Number# = 1 AND LogOfNumber# = 1 THEN
    GOSUB Choice3Formula
    ERROR 18
END IF
'
'**** Calculation Choice Three Formula ****
'
NumberBase# = Number# ^ (1# / LogOfNumber#)
GOSUB Choice3Formula
COLOR 14
IF NumberBase# <= 0 THEN
    ERROR 6
END IF
PRINT NumberBase#;
NumberBase$ = MID$(STR$(NumberBase#), 2)
IF STR$(NumberBase#) = STR$(EXP(1#)) THEN
    COLOR 7
    PRINT "= ";
    COLOR 14
    NumberBase$ = "e"
    PRINT "e"
END IF
GOSUB RestartMsg
GOSUB WaitingForEnter
GOTO Begin
'
Locate15to23:
VIEW PRINT 15 TO 23
COLOR 14
CLS
GOSUB GoBackMsg
RETURN
'
Locate17to22:
VIEW PRINT 17 TO 22
COLOR 14
CLS
RETURN
'
GoBackMsg:
LOCATE 23, 25
COLOR 14
PRINT "*** Hit <Enter> to Go Back ***";
RETURN
'
RestartMsg:
VIEW PRINT 21 TO 23
CLS
COLOR 7
'** Check to see if Scientific Notation is really required **
'
Number$ = MID$(STR$(Number#), 2)
IF LogOfNumber# < 0 THEN
    LogOfNumber$ = STR$(LogOfNumber#)
ELSE
    LogOfNumber$ = MID$(STR$(LogOfNumber#), 2)
END IF
'
Msg$ = "(The Log of Number " + Number$ + " in Base " + NumberBase$ + " is " + LogOfNumber$ + ")"
MsgLength = LEN(Msg$)
IF MsgLength < 79 THEN
    LOCATE 21, (80 - MsgLength) \ 2
    PRINT Msg$;
END IF
LOCATE 23, 24, 0
COLOR 14
PRINT "*** Hit <Enter> to Re-Start ***";
RETURN
'
CheckNumber:
COLOR 7
PRINT "NUMBER ( > 0, Decimals OK): ";
COLOR 14
LINE INPUT ; Number$
Number$ = UCASE$(LTRIM$(RTRIM$(Number$)))
IF Number$ = "" THEN
    RETURN
ELSEIF LEFT$(Number$, 1) = "0" THEN
    Bad = -1
    RETURN
ELSEIF RIGHT$(Number$, 1) = "." THEN
    Bad = -1
    RETURN
END IF
Flag1 = 0
Flag2 = 0
FOR X = 1 TO LEN(Number$)
    IF MID$(Number$, X, 1) = "." THEN
        Flag1 = Flag1 + 1
        GOTO Bypass1
    ELSEIF MID$(Number$, X, 1) = "D" THEN
        IF MID$(Number$, X + 1, 1) = "+" OR MID$(Number$, X + 1, 1) = "-" THEN
            Flag2 = Flag2 + 1
            GOTO Bypass1
        ELSE Bad = -1
            RETURN
        END IF
    ELSEIF INSTR(Num$, MID$(Number$, X, 1)) = 0 AND Flag2 = 0 THEN
        Bad = -1
        RETURN
    END IF
    Bypass1:
NEXT X
IF Flag1 > 1 OR Flag2 > 1 THEN
    Bad = -1
    RETURN
ELSEIF INSTR(Num$, RIGHT$(Number$, 1)) = 0 THEN
    Bad = -1
    RETURN
ELSEIF LEFT$(Number$, 1) = "D" THEN
    Bad = -1
    RETURN
END IF
Number# = VAL(Number$)
RETURN
'
CheckNumberBase:
COLOR 7
PRINT "BASE (e, or Base > 0 and <> 1, Decimals OK): ";
COLOR 14
LINE INPUT ; NumberBase$
NumberBase$ = UCASE$(LTRIM$(RTRIM$(NumberBase$)))
IF NumberBase$ = "" THEN
    RETURN
ELSEIF LEFT$(NumberBase$, 1) = "0" THEN
    Bad = -1
    RETURN
ELSEIF RIGHT$(NumberBase$, 1) = "." THEN
    Bad = -1
    RETURN
ELSEIF LCASE$(NumberBase$) = "e" AND LEN(NumberBase$) = 1 THEN
    NumberBase$ = LCASE$(NumberBase$)
    RETURN
END IF
Flag1 = 0
Flag2 = 0
FOR X = 1 TO LEN(NumberBase$)
    IF MID$(NumberBase$, X, 1) = "." THEN
        Flag1 = Flag1 + 1
        GOTO Bypass2
    ELSEIF MID$(NumberBase$, X, 1) = "D" THEN
        IF MID$(NumberBase$, X + 1, 1) = "+" OR MID$(NumberBase$, X + 1, 1) = "-" THEN
            Flag2 = Flag2 + 1
            GOTO Bypass2
        ELSE Bad = -1
            RETURN
        END IF
    ELSEIF INSTR(Num$, MID$(NumberBase$, X, 1)) = 0 AND Flag2 = 0 THEN
        Bad = -1
        RETURN
    END IF
    Bypass2:
NEXT X
IF Flag1 > 1 OR Flag2 > 1 THEN
    Bad = -1
    RETURN
ELSEIF INSTR(Num$, RIGHT$(NumberBase$, 1)) = 0 THEN
    Bad = -1
    RETURN
ELSEIF LEFT$(NumberBase$, 1) = "D" THEN
    Bad = -1
    RETURN
END IF
NumberBase# = VAL(NumberBase$)
IF NumberBase# = 1 THEN
    Bad = -1
    RETURN
END IF
RETURN
'
CheckLog:
COLOR 7
PRINT "LOG (, Decimals OK): ";
COLOR 14
LINE INPUT ; LogOfNumber$
LogOfNumber$ = UCASE$(LTRIM$(RTRIM$(LogOfNumber$)))
IF LogOfNumber$ = "" THEN
    RETURN
ELSEIF LEFT$(LogOfNumber$, 1) = "0" AND LEN(LogOfNumber$) > 1 THEN
    Bad = -1
    RETURN
ELSEIF RIGHT$(LogOfNumber$, 1) = "-" THEN
    Bad = -1
    RETURN
END IF
IF LEFT$(LogOfNumber$, 1) = "-" THEN
    Start = 2
ELSE
    Start = 1
END IF
Flag1 = 0
Flag2 = 0
FOR X = Start TO LEN(LogOfNumber$)
    IF INSTR(Num$, MID$(LogOfNumber$, X, 1)) = 0 AND MID$(LogOfNumber$, X, 1) = "." THEN
        Flag1 = Flag1 + 1
        GOTO Bypass3
    ELSEIF MID$(LogOfNumber$, X, 1) = "D" THEN
        IF MID$(LogOfNumber$, X + 1, 1) = "+" OR MID$(LogOfNumber$, X + 1, 1) = "-" THEN
            Flag2 = Flag2 + 1
            GOTO Bypass3
        ELSE Bad = -1
            RETURN
        END IF
    ELSEIF INSTR(Num$, MID$(LogOfNumber$, X, 1)) = 0 AND Flag2 = 0 THEN
        Bad = -1
        RETURN
    END IF
    Bypass3:
NEXT X
IF Flag1 > 1 OR Flag2 > 1 THEN
    Bad = -1
    RETURN
ELSEIF INSTR(Num$, RIGHT$(LogOfNumber$, 1)) = 0 THEN
    Bad = -1
    RETURN
ELSEIF LEFT$(LogOfNumber$, 1) = "D" THEN
    Bad = -1
    RETURN
END IF
LogOfNumber# = VAL(LogOfNumber$)
RETURN
'
Choice3Formula:
LOCATE 19, 1
COLOR 7
Formula$ = MID$(STR$(Number#), 2) + " ^ (1 /" + MID$(STR$(LogOfNumber#), 1) + ") ="
PRINT "BASE = "; Formula$;
RETURN
'
WaitingForEnter:
DO
    An$ = INKEY$
    IF LEN(An$) THEN
        IF An$ = CHR$(13) THEN
            EXIT DO
        END IF
    END IF
LOOP
RETURN
'
Oops:
VIEW PRINT 23 TO 23
COLOR 14
CLS
LOCATE 23, 15, 0
IF ERR = 11 THEN
    PRINT "*** Division by Zero";
ELSEIF ERR = 18 THEN
    LOCATE 23, 17
    PRINT "*** Invalid Base";
ELSE
    LOCATE 23, 19
    PRINT "*** Overflow";
END IF
PRINT ", Hit <Enter> to Re-Start ***";
GOSUB WaitingForEnter
RESUME Begin


